"""
This is the code for the Continuous Causal States method
described in the papers:

  Discovering Causal Structure with Reproducing-Kernel Hilbert Space ε-Machines
  by Nicolas Brodu and James P. Crutchfield

  Inferring Kernel ε-Machines: Discovering Structure in Complex Systems
  by Nicolas Brodu and Alexandra M. Jurgens1

  and possibly more to come
  
This code is free software, according to the MIT license
Author & Contact: nicolas.brodu@inria.fr
"""

# API exports

from .npda_helper import use_dask, chunk_size

from .nnls_impl import nnls

from .kernels import set_kernel, series_xy_logk, series_Gxy, embed_states, embed_Kx, compute_index_map, split_index_map, expand, series_newKx, dist_to_weights, series_newcoords, dotprod_to_dist, dotprod_to_dist2

from .dmap import spectral_basis

from .dynamics import new_coords, shift_operator, expectation_operator, predict, immediate_future, extrapolate_contiguous

from .ccutils import plot_series, plot_trajectories, plot3D
